/*
 * 特训营团队排行榜
 */

using System;
using System.Web;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Threading.Tasks;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Http;
using Microsoft.Extensions.Logging;
using Microsoft.Extensions.Options;
using MySystem.Models;
using Library;
using LitJson;
using MySystemLib;

namespace MySystem.Areas.Admin.Controllers
{
    [Area("Admin")]
    [Route("Admin/[controller]/[action]")]
    public class TeamDayTopController : BaseController
    {
        public TeamDayTopController(IHttpContextAccessor accessor, ILogger<BaseController> logger, IOptions<Setting> setting) : base(accessor, logger, setting)
        {
            OtherMySqlConn.connstr = ConfigurationManager.AppSettings["SqlConnStr"].ToString();
        }

        #region 特训营团队排行榜列表

        /// <summary>
        /// 根据条件查询特训营团队排行榜列表
        /// </summary>
        /// <returns></returns>
        public IActionResult Index(TeamDayTop data, string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;

            return View();
        }

        #endregion

        #region 根据条件查询特训营团队排行榜列表

        /// <summary>
        /// 特训营团队排行榜列表
        /// </summary>
        /// <returns></returns>
        public JsonResult IndexData(TeamDayTop data, string TopUserIdMakerCode, string TopUserIdRealName, string TeamIdTeamNo, string TeamIdTeamName, string TeamUserIdMakerCode, string TeamUserIdRealName, int page = 1, int limit = 30)
        {

            Dictionary<string, string> Fields = new Dictionary<string, string>();

            Fields.Add("TeamStartDate", "3"); //队伍开始时间


            string condition = " and Status>-1";
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopUserIdMakerCode))
            {
                condition += " and TopUserId in (select TopUserId from UserForMakerCode where MakerCode='" + TopUserIdMakerCode + "')";
            }
            //顶级创客真实姓名
            if (!string.IsNullOrEmpty(TopUserIdRealName))
            {
                condition += " and TopUserId in (select TopUserId from UserForRealName where RealName='" + TopUserIdRealName + "')";
            }
            //队伍队伍编码
            if (!string.IsNullOrEmpty(TeamIdTeamNo))
            {
                condition += " and TeamId in (select TeamId from TeamApplyForTeamNo where TeamNo='" + TeamIdTeamNo + "')";
            }
            //队伍队伍名称
            if (!string.IsNullOrEmpty(TeamIdTeamName))
            {
                condition += " and TeamId in (select TeamId from TeamApplyForTeamName where TeamName='" + TeamIdTeamName + "')";
            }
            //团队长创客编号
            if (!string.IsNullOrEmpty(TeamUserIdMakerCode))
            {
                condition += " and TeamUserId in (select TeamUserId from UserForMakerCode where MakerCode='" + TeamUserIdMakerCode + "')";
            }
            //团队长创客真实姓名
            if (!string.IsNullOrEmpty(TeamUserIdRealName))
            {
                condition += " and TeamUserId in (select TeamUserId from UserForRealName where RealName='" + TeamUserIdRealName + "')";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TeamDayTop", Fields, "Id desc", "0", page, limit, condition);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //顶级创客
                int TopUserId = int.Parse(function.CheckInt(dic["TopUserId"].ToString()));
                Users topuserid_Users = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopUserIdMakerCode"] = topuserid_Users.MakerCode;
                dic["TopUserIdRealName"] = topuserid_Users.RealName;
                dic.Remove("TopUserId");
                //队伍
                int TeamId = int.Parse(function.CheckInt(dic["TeamId"].ToString()));
                TeamApply teamid_TeamApply = db.TeamApply.FirstOrDefault(m => m.Id == TeamId) ?? new TeamApply();
                dic["TeamIdTeamNo"] = teamid_TeamApply.TeamNo;
                dic["TeamIdTeamName"] = teamid_TeamApply.TeamName;
                dic.Remove("TeamId");
                //团队长创客
                int TeamUserId = int.Parse(function.CheckInt(dic["TeamUserId"].ToString()));
                Users teamuserid_Users = db.Users.FirstOrDefault(m => m.Id == TeamUserId) ?? new Users();
                dic["TeamUserIdMakerCode"] = teamuserid_Users.MakerCode;
                dic["TeamUserIdRealName"] = teamuserid_Users.RealName;
                dic.Remove("TeamUserId");

            }
            return Json(obj);
        }

        #endregion

        #region 增加特训营团队排行榜

        /// <summary>
        /// 增加或修改特训营团队排行榜信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Add(string right)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            return View();
        }

        #endregion

        #region 增加特训营团队排行榜

        /// <summary>
        /// 增加或修改特训营团队排行榜信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Add(TeamDayTop data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            int Id = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Add("TeamDayTop", Fields, 0);
            AddSysLog(data.Id.ToString(), "TeamDayTop", "add");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 修改特训营团队排行榜

        /// <summary>
        /// 增加或修改特训营团队排行榜信息
        /// </summary>
        /// <returns></returns>
        public IActionResult Edit(string right, int Id = 0)
        {
            ViewBag.RightInfo = RightInfo;
            ViewBag.right = right;


            TeamDayTop editData = db.TeamDayTop.FirstOrDefault(m => m.Id == Id) ?? new TeamDayTop();
            ViewBag.data = editData;
            return View();
        }

        #endregion

        #region 修改特训营团队排行榜

        /// <summary>
        /// 增加或修改特训营团队排行榜信息
        /// </summary>
        /// <returns></returns>
        [HttpPost]
        public string Edit(TeamDayTop data)
        {
            Dictionary<string, object> Fields = new Dictionary<string, object>();


            Fields.Add("SeoTitle", data.SeoTitle);
            Fields.Add("SeoKeyword", data.SeoKeyword);
            Fields.Add("SeoDescription", data.SeoDescription);
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamDayTop", Fields, data.Id);
            AddSysLog(data.Id.ToString(), "TeamDayTop", "update");
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 删除特训营团队排行榜信息

        /// <summary>
        /// 删除特训营团队排行榜信息
        /// </summary>
        /// <returns></returns>
        public string Delete(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TeamDayTop", "del");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", -1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamDayTop", Fields, id);
            }
            db.SaveChanges();

            return "success";
        }

        #endregion

        #region 开启

        /// <summary>
        /// 开启
        /// </summary>
        /// <returns></returns>
        public string Open(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TeamDayTop", "open");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 1);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamDayTop", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 关闭

        /// <summary>
        /// 关闭
        /// </summary>
        /// <returns></returns>
        public string Close(string Id)
        {
            string[] idlist = Id.Split(new char[] { ',' });
            AddSysLog(Id, "TeamDayTop", "close");
            foreach (string subid in idlist)
            {
                int id = int.Parse(subid);
                Dictionary<string, object> Fields = new Dictionary<string, object>();
                Fields.Add("Status", 0);
                new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Edit("TeamDayTop", Fields, id);
            }
            db.SaveChanges();
            return "success";
        }

        #endregion

        #region 排序
        /// <summary>
        /// 排序
        /// </summary>
        /// <param name="Id"></param>
        public string Sort(int Id, int Sort)
        {
            new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).Sort("TeamDayTop", Sort, Id);

            AddSysLog(Id.ToString(), "TeamDayTop", "sort");
            return "success";
        }
        #endregion

        #region 导入数据
        /// <summary>
        /// 导入数据
        /// </summary>
        /// <param name="ExcelData"></param>
        public string Import(string ExcelData)
        {
            ExcelData = HttpUtility.UrlDecode(ExcelData);
            JsonData list = JsonMapper.ToObject(ExcelData);
            for (int i = 1; i < list.Count; i++)
            {
                JsonData dr = list[i];

                db.TeamDayTop.Add(new TeamDayTop()
                {
                    CreateDate = DateTime.Now,
                    UpdateDate = DateTime.Now,

                });
                db.SaveChanges();
            }
            AddSysLog("0", "TeamDayTop", "Import");
            return "success";
        }
        #endregion

        #region 导出Excel

        /// <summary>
        /// 导出Excel
        /// </summary>
        /// <returns></returns>
        public JsonResult ExportExcel(TeamDayTop data, string TopUserIdMakerCode, string TopUserIdRealName, string TeamIdTeamNo, string TeamIdTeamName, string TeamUserIdMakerCode, string TeamUserIdRealName)
        {
            Dictionary<string, string> Fields = new Dictionary<string, string>();
            Fields.Add("TeamStartDate", "3"); //队伍开始时间


            string condition = " and Status>-1";
            //顶级创客编号
            if (!string.IsNullOrEmpty(TopUserIdMakerCode))
            {
                condition += " and TopUserId in (select TopUserId from UserForMakerCode where MakerCode='" + TopUserIdMakerCode + "')";
            }
            //顶级创客真实姓名
            if (!string.IsNullOrEmpty(TopUserIdRealName))
            {
                condition += " and TopUserId in (select TopUserId from UserForRealName where RealName='" + TopUserIdRealName + "')";
            }
            //队伍队伍编码
            if (!string.IsNullOrEmpty(TeamIdTeamNo))
            {
                condition += " and TeamId in (select TeamId from TeamApplyForTeamNo where TeamNo='" + TeamIdTeamNo + "')";
            }
            //队伍队伍名称
            if (!string.IsNullOrEmpty(TeamIdTeamName))
            {
                condition += " and TeamId in (select TeamId from TeamApplyForTeamName where TeamName='" + TeamIdTeamName + "')";
            }
            //团队长创客编号
            if (!string.IsNullOrEmpty(TeamUserIdMakerCode))
            {
                condition += " and TeamUserId in (select TeamUserId from UserForMakerCode where MakerCode='" + TeamUserIdMakerCode + "')";
            }
            //团队长创客真实姓名
            if (!string.IsNullOrEmpty(TeamUserIdRealName))
            {
                condition += " and TeamUserId in (select TeamUserId from UserForRealName where RealName='" + TeamUserIdRealName + "')";
            }


            Dictionary<string, object> obj = new AdminContentOther(_accessor.HttpContext, PublicFunction.MainTables).IndexData("TeamDayTop", Fields, "Id desc", "0", 1, 20000, condition, "TopUserId,TeamId,TeamUserId,TeamStartDate,TeamEndDate,TeamActMerNum", false);
            List<Dictionary<string, object>> diclist = obj["data"] as List<Dictionary<string, object>>;
            foreach (Dictionary<string, object> dic in diclist)
            {
                //顶级创客
                int TopUserId = int.Parse(function.CheckInt(dic["TopUserId"].ToString()));
                Users topuserid_Users = db.Users.FirstOrDefault(m => m.Id == TopUserId) ?? new Users();
                dic["TopUserIdMakerCode"] = topuserid_Users.MakerCode;
                dic["TopUserIdRealName"] = topuserid_Users.RealName;
                dic.Remove("TopUserId");
                //队伍
                int TeamId = int.Parse(function.CheckInt(dic["TeamId"].ToString()));
                TeamApply teamid_TeamApply = db.TeamApply.FirstOrDefault(m => m.Id == TeamId) ?? new TeamApply();
                dic["TeamIdTeamNo"] = teamid_TeamApply.TeamNo;
                dic["TeamIdTeamName"] = teamid_TeamApply.TeamName;
                dic.Remove("TeamId");
                //团队长创客
                int TeamUserId = int.Parse(function.CheckInt(dic["TeamUserId"].ToString()));
                Users teamuserid_Users = db.Users.FirstOrDefault(m => m.Id == TeamUserId) ?? new Users();
                dic["TeamUserIdMakerCode"] = teamuserid_Users.MakerCode;
                dic["TeamUserIdRealName"] = teamuserid_Users.RealName;
                dic.Remove("TeamUserId");

            }

            Dictionary<string, object> result = new Dictionary<string, object>();
            result.Add("Status", "1");
            result.Add("Info", "Excel报表-" + DateTime.Now.ToString("yyyy-MM-ddTHH:mm:ss") + ".xlsx");
            result.Add("Obj", diclist);
            Dictionary<string, object> ReturnFields = new Dictionary<string, object>();
            ReturnFields.Add("TopUserIdMakerCode", "顶级创客编号");
            ReturnFields.Add("TopUserIdRealName", "顶级创客姓名");
            ReturnFields.Add("TeamIdTeamNo", "队伍编码");
            ReturnFields.Add("TeamIdTeamName", "队伍名称");
            ReturnFields.Add("TeamUserIdMakerCode", "团队长创客编号");
            ReturnFields.Add("TeamUserIdRealName", "团队长创客姓名");
            ReturnFields.Add("TeamStartDate", "队伍开始时间");
            ReturnFields.Add("TeamEndDate", "队伍结束时间");
            ReturnFields.Add("TeamActMerNum", "激活商户数");

            result.Add("Fields", ReturnFields);
            AddSysLog("0", "TeamDayTop", "ExportExcel");
            return Json(result);
        }

        #endregion

    }
}
